<?xml version="1.0" encoding="utf-8"?>
<!--
    
    ****************************************************************************************
    
    European Union Public Licence - EUPL v.1.1
    
    Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl
    
    Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
    European Commission - subsequent versions of the EUPL (the "Licence");
    You may not use this work except in compliance with the Licence.
    You may obtain a copy of the Licence at:
    
    http://ec.europa.eu/idabc/eupl
    
    Unless required by applicable law or agreed to in writing, software distributed
    under the Licence is distributed on an "AS IS" basis, 
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the Licence for the specific language governing permissions and limitations
    under the Licence.
    
    ****************************************************************************************
    
-->
<xsl:stylesheet  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:functx="http://www.functx.com"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:msg="http://www.sonnenglanz.net/2010/07/09/smf.services.2.0.xsd"
    xmlns:axsl="http://www.w3.org/1999/XSL/TransformAlias" version="2.0"
    xmlns:ss="urn:schemas-microsoft-com:office:spreadsheet"
    exclude-result-prefixes="xsl xsi functx xs xs axsl ss">
    <xsl:strip-space elements="*"/>
    
    <xsl:output method="xml" encoding="utf-8" indent="yes"/>
    
    <xsl:function name="functx:capitalize-first" as="xs:string?" xmlns:functx="http://www.functx.com" >
        <xsl:param name="arg" as="xs:string?"/>
        <xsl:sequence select="concat(upper-case(substring($arg,1,1)),substring($arg,2))"/>
    </xsl:function>
    
    <xsl:function name="functx:words-to-camel-case" as="xs:string"  xmlns:functx="http://www.functx.com" >
        <xsl:param name="arg" as="xs:string?"/>
        <xsl:sequence select="string-join((tokenize($arg,'\s+')[1], for $word in tokenize($arg,'\s+')[position() > 1] return functx:capitalize-first($word)),'')"/>
    </xsl:function>
    
    <xsl:template match="/">
        <msg:specification>
            <msg:profiles>
                <xsl:comment>Just as an example. Modify to your own needs!!!!!!!!!!!! </xsl:comment>
                <xsl:comment>I do not even know if this profile is defined.... So, think about the required characteristics....</xsl:comment>
                <msg:profile name="jab-basis" transport="reliable" retryInterval="PT3H" retryCount="8"/>
            </msg:profiles>
            <msg:services>
                <msg:service serviceId="s1" process="DeProcesNaam" service="DeServiceIdentificatie" serviceType="OptioneelServiceType">
                    <xsl:apply-templates select="/Workbook/Worksheet/Table"/> <!-- Worksheet ss:Name="Message Specification" -->
                </msg:service>
            </msg:services>
            <msg:rolebindings>
                <xsl:comment>I was just too lazy to determine the different roles. Modify to your own needs!!!!!!!!!!!!</xsl:comment>
                <msg:binding name="Name1" parameterId="p1">
                    <msg:role serviceId="s1" name="Role_in_s1"/>
                </msg:binding>
                <msg:binding name="Name2" parameterId="p1">
                    <msg:role serviceId="s1" name="Role_In_s1"/>
                </msg:binding>
            </msg:rolebindings>
            <msg:parameters>
                <msg:group parameterId="p1">
                    <xsl:comment>The most basic default parameters. Modify to your own needs!!!!!!!!!!!!</xsl:comment>
                    <msg:parameter name="PartyName" required="true"/>
                    <msg:parameter name="PartyRef" required="true"/>
                    <msg:parameter name="PartyId" required="true"/>
                    <msg:parameter name="PartyIdType" required="true"/>
                    <msg:parameter name="EndpointUri" required="true"/>
                </msg:group>
            </msg:parameters>
        </msg:specification>
    </xsl:template>

    <xsl:template match="Row">
        <xsl:variable name="TDid"><xsl:value-of select="translate(Cell[1]/Data, '-','')"/></xsl:variable>
        <xsl:variable name="BDid"> <xsl:value-of select="translate(Cell[2]/Data, '-','')"/></xsl:variable>
        <xsl:variable name="Name"><xsl:value-of select="functx:words-to-camel-case(Cell[4]/Data)"/></xsl:variable>
        <xsl:variable name="From"> <xsl:value-of select="Cell[5]/Data"/></xsl:variable>
        <xsl:variable name="To"> <xsl:value-of select="Cell[6]/Data"/></xsl:variable>
        <xsl:variable name="Profile"> <xsl:value-of select="Cell[7]/Data"/></xsl:variable>
        <msg:message from="{$From}" to="{$To}" id="{concat($TDid,'_',$BDid)}" profile="{$Profile}">
            <xsl:value-of select="$Name"/>
        </msg:message>
    </xsl:template>

</xsl:stylesheet>
