#!"..\Python\App\python.exe" -u

"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""
    
import cgi
import os, sys, string
import getRoles
import cpaform
import webformcpaid
import getServiceId
import utilities
import myProperties

html_fallback = {
u'nl' : """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<html><head>
<title>CPA Creatie Toolkit - Oops... er zijn fouten opgetreden</title>
<link rel="stylesheet" title="CpaToolkit default" type="text/css" media="screen" href="/table-in-css.css">
</head>
<body>
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creatie</h2>
<h1>Oops... er zijn fouten opgetreden</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Service Specificatie</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Er zijn fouten geconstateerd in de configuratie van de CPA Creatie Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
</body>
</html>
""",
u'en' : """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<html><head>
<title>CPA Creation Toolkit - Oops... an error has occurred!</title>
<link rel="stylesheet" title="CpaToolkit default" type="text/css" media="screen" href="/table-in-css.css">
</head>
<body>
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creation</h2>
<h1>Oops... an error has occurred!</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Service Specificatie</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Errors have been identified in the configuration of the CPA Creation Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
</body>
</html>
"""
}

def main():
    print "Content-type: text/html\n" # Do this first
    try:
        profile  = "1"
        
        myCpaForm  = cpaform.CpaForm()
        myCpaForm.Process(None) 
        myID = myCpaForm.name

        # Process web form
        if (myCpaForm.status):
            profile = myCpaForm.profile
        # Check status
        if (not myCpaForm.status):
            if myCpaForm.errormessage:
                getServiceId.main(notification=myCpaForm.errormessage, language=myCpaForm.language)
            else:
                getServiceId.main(notification=myCpaForm.name, language=myCpaForm.language)
            return False

        # Determine configuration
        config = myProperties.Properties(myCpaForm.language)
        if (config.error):
            myError = "ERROR assignPartyToRole.py; Could not initialize.<BR>"
            myError = myError + config.error,"<BR>"
            language = u'en'
            if myCpaForm:
                if myCpaForm.language:
                    language = myCpaForm.language
            myString = html_fallback[language] 
            myString = myString.replace('__NOTIFICATION_PH__', str(sys.exc_info()[1]))
            print myString
            return

        myFile      = os.path.join(config.HTMLResultTemplate,'id', 'stap2.html')
        filePath=os.path.join(myFile)
        f = open(filePath,'rb')
        myString = f.read(-1)
        f.close()
        myDir       = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'p'))
        myParticipantsList  = utilities.makeListFromTemplate(utilities.getDirectoryList(myDir), "<OPTION VALUE=\"__PH__\">__PH__","__PH__")

        myTemplate  = "__ID_PH__"
        myString = myString.replace(myTemplate, str(myID))
        myString = myString.replace(myTemplate, str(myID))
        myString = myString.replace('__PH_PROFILE__',profile)
        
        myServiceDir   = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'c'))
        myServiceFile = os.path.join(os.path.abspath(myServiceDir), myID, myID+'.msg.xml')
        myMsg = getRoles.ServiceSpecification()

        #---------------------------------------------------------------------------------
        status = True
        myError = ""
        notification = { u'nl':'Er zijn fouten opgetreden bij het verwerken van de service specificatie: ',
                         u'en':'Errors occurred during the processing of the service specification: '
                         }
        if not myMsg.set(myServiceFile, 'smf'):
            myError = utilities.redHtmlFormat(notification[myCpaForm.language]+ myCpaForm.name) + "<BR><BR>" + myMsg.errorMessage() + "<BR>"
            status = False
        if not myMsg.get():
            myError = myError + myMsg.errorMessage() + "<BR>"
            status = False
        myPairs = myMsg.getPairs()
        if not myPairs:
            myMsg.errorMessage()
        myRoles = myMsg.getRoles()
        if not myRoles:
            myError = myError + myMsg.errorMessage() + "<BR>"
            status = False
        # Check status
        if (not status):
            getServiceId.main(notification=myError, language=myCpaForm.language)
            return False
        #---------------------------------------------------------------------------------
        
        myFormProcessor = webformcpaid.WebFormCreateCpaWithIDS()
        if myFormProcessor.createHtmlSelect(myString, myRoles, myParticipantsList):
            myString = myFormProcessor.getHtmlString()
        print myString
        return True
    except:
        language = u'en'
        if myCpaForm:
            if myCpaForm.language:
                language = myCpaForm.language
        #
        myString = html_fallback[language].replace('__NOTIFICATION_PH__', str(sys.exc_info()[1]))
        print myString
        #cgi.print_exception()
        return False
main()