"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import cgi
import cgitb; cgitb.enable()
import os, sys
import shutil
import utilities
import uuid
import webformcpaid
import messages

def _(id, language):
    return messages.Translation(id, language)

class dummyForm:
    def __init__(self, value):
        self.value = value

class CpaForm:
    def __init__(self):
        self.status = True
        self.formType = None
        self.formTypes= ['sp','sr','onestep','template', 'participant', 'cciat', 'specifier']
        self.code   = ""
        self.upload = None
        self.assignedRoles = None
        self.partyA = utilities.redHtmlFormat("Geef naam van Partij A.")
        self.partyB = utilities.redHtmlFormat("Geef naam van Partij B.")
        self.partyIdA = None
        self.partyIdB = None
        self.profile= utilities.redHtmlFormat("Geef de profiel naam op.")
        self.profileTypes = ['1', '2', '3', '4']
        self.name   = utilities.redHtmlFormat("Geef de ID op.")
        self.versie = ""
        self.useAsCpaId = False
        self.start  = ""
        self.eind   = ""
        self.msg    = utilities.redHtmlFormat("Geef de msg.xml file op.")
        self.params = utilities.redHtmlFormat("Geef de params.xml op.")
        self.paramsA= utilities.redHtmlFormat("Geef de parameters voor partij A op.")
        self.paramsB= utilities.redHtmlFormat("Geef de parameters voor partij B op.")
        self.persoonsnaam   = utilities.redHtmlFormat("(Default)")
        self.email  = utilities.redHtmlFormat("(Default)")
        self.errormessage = ""
        self.specificationType = "None"
        self.specificationTypes = ['smf', 'template', 'id', 'id2', 'params']
        self.koppeling = "default"
        self.koppelingTypes = ['Direkt', 'Intermediair']
        self.saveresults = False
        self.language = u'en' # Default language
        #
        #==========================================================
        # Quick hack for the postprocessing by means of the changeCPAID.xsl XSLT
        self.baseHREF       = None
        self.baseUUID       = None
        self.httpsIncrement = None
        #==========================================================
        
    def Process(self, upload_dir, emailName=None, emailAddress=None):
        try:
            """
            Start scanning Form
            """
            result = 0
            form = cgi.FieldStorage()
            myFormProcessor = webformcpaid.WebFormCreateCpaWithIDS()
            #print form

            #*******************************************************************
            # Language
            value = myFormProcessor.getKey(form, 'language', 2)
            if value:
                self.language = value
            else:
                self.status = False
                self.errormessage = self.errormessage + utilities.redHtmlFormat("There is no language specified. Used English as default.")+"<br>"
                if myFormProcessor.errormessage:
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(myFormProcessor.errormessage)
            #
            myFormProcessor.setLanguage(self.language)

            #*******************************************************************
            # If the field is present, should the results be saved?
            value = myFormProcessor.getKey(form, 'saveresults', 20)
            if value:
                self.saveresults = True
                #print "Results will be saved."
 
            #*******************************************************************
            # Formulier type
            value = myFormProcessor.getKey(form, 'FormType', 20)
            if value and (value in self.formTypes):
                self.formType = value
            else:
                if myFormProcessor.errormessage:
                    self.formType = utilities.redHtmlFormat(myFormProcessor.errormessage)
                if not (value in self.formTypes):
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(27, self.language))+"<br>"
                    self.formType = utilities.redHtmlFormat(_(28, self.language))
                self.status = False

            #*******************************************************************
            # Specificatie type
            value = myFormProcessor.getKey(form, 'specificationtype', 20)
            if value and (value in self.specificationTypes):
                self.specificationType = value
            else:
                if myFormProcessor.errormessage:
                    self.formType = utilities.redHtmlFormat(myFormProcessor.errormessage)
                if not (value in self.specificationTypes):
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(29, self.language))+"<br>"
                    self.specificationType = utilities.redHtmlFormat(_(30, self.language))
                self.status = False

            #*******************************************************************
            # Profile
            value = myFormProcessor.getKey(form, 'Profile', 10)
            if value and (value in self.profileTypes):
                self.profile = value
            else:
                if myFormProcessor.errormessage:
                    self.profile = utilities.redHtmlFormat(myFormProcessor.errormessage)
                elif not (value in self.profileTypes):
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(31, self.language))+"<br>"
                    self.profile = utilities.redHtmlFormat(_(32, self.language))
                else:
                    self.profile = utilities.redHtmlFormat(_(32, self.language))
                self.status = False 
         
            #*******************************************************************
            # ID
            value = myFormProcessor.getKey(form, 'ID', 40)
            if value:
                self.name = value.replace(' ','')
            else:
                if ((self.formType == 'onestep')) and (not ((self.specificationType == 'id') or (self.specificationType == 'id2'))):
                    self.name = str(uuid.uuid1())
                else:
                    self.status = False
                    if myFormProcessor.errormessage:
                        self.name = utilities.redHtmlFormat(myFormProcessor.errormessage)
                        self.errormessage = self.errormessage + utilities.redHtmlFormat(_(33, self.language)) + "<br>" 
                    else:
                        self.name = utilities.redHtmlFormat(_(34, self.language))

            #*******************************************************************
            # CPA ID (indien afwezig genereerd het systeem zelf een ID
            value = myFormProcessor.getKey(form, 'CPAIDversie', 40)
            if value:
                self.versie = value.replace(' ','')
                useAsCpaId = myFormProcessor.getKey(form, 'UseAsCpaId', 40)
                if useAsCpaId:
                    self.useAsCpaId = True
            else:
                if myFormProcessor.errormessage:
                    self.status = False
                    self.versie = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(35, self.language)) + "<br>" 

            #*******************************************************************
            # Start Datum van de CPA ID
            value = myFormProcessor.getKeyDatum(form, 'CPAIDstart', 40) # Optioneel !!!
            if value:
                self.start = value
            else:
                if myFormProcessor.errormessage:
                    self.status = False
                    self.start = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(36, self.language)) + "<br>" 

            #*******************************************************************
            # Eind datum van de CPA ID
            value = myFormProcessor.getKeyDatum(form, 'CPAIDeind', 40) # Optioneel !!!
            if value:
                self.eind = value
            else:
                if myFormProcessor.errormessage:
                    self.status = False
                    self.eind = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(37, self.language)) + "<br>" 

            #*******************************************************************
            # Party & Role Info based on generated sequence of RoleNo and PartyIdNo...
            if (self.specificationType == 'id2'):
                if myFormProcessor.getPairsFromWebForm(form):
                    self.assignedRoles = myFormProcessor.getAssignedRoles()
                else:
                    self.status = False
                    self.errormessage = self.errormessage +myFormProcessor.message+"<br>"

            #*******************************************************************
            # Party & Role Info
            if (not ((self.formType == 'specifier') or (self.formType == 'collaboration'))) and (not (self.specificationType == 'id2')) and (not ((self.specificationType == 'id') and (self.formType == 'onestep'))):
                # Determine rolename for party A
                value = myFormProcessor.getKey(form, 'PartyA', 40)
                if value:
                    self.partyA = value.replace(' ','')
                else:
                    # Derive from the filename (if possible)
                    if form.has_key("FileParamsA"):
                        parametersFilename=utilities.getFilename((form["FileParamsA"].filename)[0:100])
                        rolA = utilities.getRole(parametersFilename)
                        if not rolA:
                            self.errormessage = self.errormessage + _(38, self.language) + "<br>"
                            self.status = False
                        elif rolA != utilities.filterKey(rolA):
                            self.errormessage = self.errormessage + _(39, self.language) + "<br>"
                            self.status = False
                        else:
                            self.partyA = rolA
                    else:
                        self.errormessage = self.errormessage + _(40, self.language) + "<br>"
                        self.status = False
                # Determine rolename for party B
                value = myFormProcessor.getKey(form, 'PartyB', 40)
                if value:
                    self.partyB = value
                else:
                    # Derive from the filename (if possible)
                    if form.has_key("FileParamsB"):
                        parametersFilename=utilities.getFilename((form["FileParamsB"].filename)[0:100])
                        rolB = utilities.getRole(parametersFilename)
                        if not rolB:
                            self.errormessage = self.errormessage + _(41, self.language) + "<br>"
                            self.status = False
                        elif rolB != utilities.filterKey(rolB):
                            self.errormessage = self.errormessage + _(39, self.language) + "<br>"
                            self.status = False
                        else:
                            self.partyB = rolB
                    else:
                        self.errormessage = self.errormessage + _(42, self.language) +"<br>"
                        self.status = False

            #*******************************************************************
            # Identify the partners by means of their ID, as stored in the repository.
            if (self.formType == 'collaboration'):
                # Party A
                value = myFormProcessor.getKey(form, 'IDPartyA', 40)
                if value:
                    self.partyIdA = value
                else:
                    self.status = False
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(43, self.language))+"<br>"
                # Party B
                value = myFormProcessor.getKey(form, 'IDPartyB', 40)
                if value:
                    self.partyIdB = value
                else:
                    self.status = False
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(44, self.language))+"<br>"

            #*******************************************************************
            # Naam van de persoon
            #print "emailName: ",emailName,"|emailAddress: ",emailAddress,"<BR>"
            value = myFormProcessor.getKeyNaam(form, 'Persoonsnaam', 50)
            if value:
                self.persoonsnaam = value
            else:
                if myFormProcessor.errormessage:
                    self.status = False
                    self.persoonsnaam = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(45, self.language))+"<br>"
                elif emailName:
                    myDummyWebForm = {}
                    myDummyWebForm['Persoonsnaam'] = dummyForm(emailName)
                    value = myFormProcessor.getKeyNaam(myDummyWebForm, 'Persoonsnaam', 50)
                    #print "Default: ", value,"<BR>"
                    if value:
                        self.persoonsnaam = value
                    else:
                        self.status = False
                        self.persoonsnaam = utilities.redHtmlFormat(myFormProcessor.errormessage)
                        self.errormessage = self.errormessage + utilities.redHtmlFormat(_(45, self.language))+"<br>"
                else:
                    self.status = False
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(46, self.language))+"<br>"
            #*******************************************************************
            # Email adres van de persoon
            value = myFormProcessor.getKeyEmail(form, 'Email', 60)
            if value:
                self.email = value
            else:
                if myFormProcessor.errormessage:
                    self.status = False
                    self.email = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(47, self.language))+"<br>"
                elif emailAddress:
                    myDummyWebForm = {}
                    myDummyWebForm['Email'] = dummyForm(emailAddress)
                    value = myFormProcessor.getKeyEmail(myDummyWebForm, 'Email', 60)
                    if value:
                        self.email = value
                    else:
                        self.status = False
                        self.email = utilities.redHtmlFormat(myFormProcessor.errormessage)
                        self.errormessage = self.errormessage + utilities.redHtmlFormat(_(47, self.language))+"<br>"
                else:
                    self.status = False
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(48, self.language))+"<br>"

            #*******************************************************************
            # Invoer van specificaties
            if ((self.formType == 'onestep') and (not ((self.specificationType == 'id') or (self.specificationType == 'id2')))) or (self.formType == 'sp') or (self.formType == 'specifier'):
                msgFilename = ""
                try:
                    if self.name == utilities.filterKey(self.name):
                        filename = os.path.join(upload_dir, self.name+'.msg.xml')
                    else:
                        filename = None
                    value = myFormProcessor.getFile(form,'FileMsgSpec', 100, filename, 102400)
                    if value:
                        if (self.formType == 'template') or (self.formType == 'onestep'):
                            self.msg = value.replace(' ','')
                        else:
                            self.paramsA = value.replace(' ','')
                            self.msg = value
                    else:
                        if myFormProcessor.errormessage:
                            self.msg = utilities.redHtmlFormat(myFormProcessor.errormessage)
                        self.status = False
                except:
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(49, self.language))+"<br>"
                    self.errormessage = self.errormessage + str(sys.exc_info()[1])+"<br>"
                    self.status = False

            if ((self.formType == 'onestep') and (not ((self.specificationType == 'id') or self.specificationType == 'id2'))) or (self.formType == 'sp'):
                FileParamsAExists = False
                parametersFilename = ""
                try:
                    if form.has_key("IDPartyA") and form["IDPartyA"].value != "":
                        self.partyIdA    = form['IDPartyA'].value
                        parametersFilename = self.partyIdA
                    else:
                        if form.has_key("FileParamsA"):
                            paramsA = form["FileParamsA"]
                            parametersFilename=utilities.getFilename(form["FileParamsA"].filename)
                            if self.status:
                                if len(paramsA.value)>0:
                                    paramsAfout = file (os.path.join(upload_dir, self.partyA+'.parameters.xml'), 'wb')
                                    while 1:
                                        chunk = paramsA.file.read(100000)
                                        if not chunk: break
                                        paramsAfout.write (chunk)
                                    paramsAfout.close()
                                    FileParamsAExists = True
                                else:
                                    self.errormessage = self.errormessage + _(50, self.language) +"<br>"
                                    self.status = False
                        else:
                            self.errormessage = self.errormessage + _(51, self.language) + "<br>"
                            self.status = False
                except:
                    self.errormessage = self.errormessage + _(52, self.language) + "<br>"
                    self.errormessage = self.errormessage + str(sys.exc_info()[1])+"<br>"
                    self.status = False
                self.paramsA = parametersFilename
                #
                if self.status:
                    myPairs = {}
                    myPairs[self.partyA] = self.partyIdA
                    myPairs[self.partyB] = self.partyIdB
                    self.assignedRoles   = myPairs

            #*******************************************************************
            # Invoeren van Participanten
            if (self.formType == 'sr') or (self.formType == 'participant'):
                # Get Participant ID
                value = myFormProcessor.getKeyNaam(form, 'ID', 50)
                if value:
                    self.partyIdB = value.replace(' ','')
                else:
                    self.status = False
                    if myFormProcessor.errormessage:
                        self.errormessage = utilities.redHtmlFormat(myFormProcessor.errormessage)
                        self.partyIdB = utilities.redHtmlFormat(_(53, self.language))
                    else:
                        self.partyIdB = utilities.redHtmlFormat(_(54, self.language))
                # Get Input File
                try:
                    if form.has_key("FileParamsB"):
                        if self.partyIdB == utilities.filterKey(self.partyIdB):
                            filename = os.path.join(upload_dir, self.partyIdB+'.parameters.xml')
                        else:
                            filename = None
                        value = myFormProcessor.getFile(form,'FileParamsB', 100, filename, 102400)
                        if value:
                            self.paramsB = value
                        else:
                            self.status = False
                            if myFormProcessor.errormessage:
                                self.paramsB = utilities.redHtmlFormat(myFormProcessor.errormessage)
                    else:
                        self.errormessage = self.errormessage + utilities.redHtmlFormat(_(18, self.language))+"<br>"
                        self.status = False                        
                except:
                    self.errormessage = self.errormessage + utilities.redHtmlFormat(_(55, self.language))+"<br>"
                    self.errormessage = self.errormessage + str(sys.exc_info()[1])+"<br>"
                    self.status = False

            #*******************************************************************
            # Rol van partij B (consumer)
            if (self.formType == 'onestep') and (not ((self.specificationType == 'id')  or (self.specificationType == 'id2'))):
                FileParamsBExists = False
                parametersFilename = ""
                try:
                    if form.has_key("IDPartyB") and form["IDPartyB"].value != "":
                        self.partyIdB    = form['IDPartyB'].value
                        parametersFilename = self.partyIdB
                    else:
                        if form.has_key("FileParamsB"):
                            paramsB = form["FileParamsB"]
                            parametersFilename=utilities.getFilename(form["FileParamsB"].filename)
                            if self.status:
                                if (len(paramsB.value)>0):
                                    paramsBfout = file (os.path.join(upload_dir, self.partyB+'.parameters.xml'), 'wb')
                                    while 1:
                                        chunk = paramsB.file.read(100000)
                                        if not chunk: break
                                        paramsBfout.write (chunk)
                                    paramsBfout.close()
                                    FileParamsBExists = True
                                else:
                                    self.errormessage = self.errormessage + _(56, self.language) + "<br>"
                                    self.status = False
                        else:
                            self.errormessage = self.errormessage + _(58, self.language) + "<br>"
                            result=1                        
                except:
                    self.errormessage = self.errormessage + _(57, self.language) + "<br>"
                    self.errormessage = self.errormessage + str(sys.exc_info()[0])+"<br>"
                    self.status = False
                self.paramsB = parametersFilename

            #*******************************************************************
            # Koppeling type
            value = myFormProcessor.getKey(form, 'koppeling', 15)
            if value and (value in self.koppelingTypes):
                # Currently only two possible value: default or intermediair
                if value == self.koppelingTypes[0]:
                    self.koppeling = "local"
                if value == self.koppelingTypes[1]:
                    self.koppeling = "default"
            elif value and (not (value in self.koppelingTypes)):
                self.errormessage = self.errormessage + _(59, self.language) + "<br>"
                self.koppeling = utilities.redHtmlFormat(_(60, self.language))
                self.status = False
            elif myFormProcessor.errormessage:
                self.errormessage = self.errormessage + utilities.redHtmlFormat(myFormProcessor.errormessage)
                self.status = False

            return
        except:
            self.status = False
            self.errormessage = self.errormessage + _(61, self.language) + "<br>"+str(sys.exc_info()[1])+"<br>"
        return
