#!"..\Python\App\python.exe" -u

"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import cgi
import os, sys, string
import utilities
import getRoles
import myProperties

message = {
(u'nl',u'noID'):u'De ID is niet gespecificeerd.',
(u'en',u'noID'):u'The ID is not specified.',
(u'nl',u'noINFO'):u'De informatie is niet gevonden voor de opgegeven ID ',
(u'en',u'noINFO'):u'No information was found for the specified ID ',
(u'nl',u'processing'):u'Er is een fout opgetreden bij het verwerken van het verzoek met de ID ',
(u'en',u'processing'):u'An error occurred while processing the request for the ID ',
}

html_fallback = {
u'nl' : """
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creatie</h2>
<h1>Inhoud tonen</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>De inhoud kon niet worden getoond.</strong></div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
""",
u'en' : """
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creation</h2>
<h1>Show Contents</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>The contents could not be presented.</strong></div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
"""
}

def main():
    try:
        miniForm = cgi.FormContent()
        
        language  = u'en'  # Default language
        if miniForm.has_key('language'):
            value = miniForm['language'][0][0:2]
            if value in [u'nl',u'en']:
                language = value

        type = ""
        if miniForm.has_key('type'):
            type = miniForm['type'][0]
            
        ref = ""
        if miniForm.has_key('ref'):
            ref = miniForm['ref'][0]
            
        profile = "1"
        if miniForm.has_key('profile'):
            value = miniForm['profile'][0]
            if value in ['1', '2', '3', '4']:
                profile = value

        config = myProperties.Properties()
        if (config.error):
            print "Content-type: text/html\n" # Do this first
            print """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><HTML><HEAD><TITLE>CPA Creation Toolkit - Version 4.0</TITLE>"""
            print """<link rel="stylesheet" title="CPA Creation Toolkit" type="text/css" media="screen" href="/table-in-css.css"></HEAD><BODY>"""
            myError = "ERROR getContents.py; Could not initialize.<BR>" + config.error + "<BR>"
            if not html_fallback.has_key(language):
                language = u'en'
            myString = html_fallback[language].replace("__NOTIFICATION_PH__", myError)
            print myString
            print "</BODY></HMTL>"
            return

        myServiceDir                = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'c'))
        myParticipantDir            = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'p'))
        myDownloadDir               = config.DownloadDir #os.path.join(apacheDir, 'cpa', '4', '0', 'downloads')        

        myID = ref
        header= "Content-Type: application/xml; Content-Disposition: attachment; filename=specification.xml; charset=utf-8\n"
        if (type == 's') or (type == 'msg'):
            myDir   = myServiceDir 
            myFile  = os.path.join(os.path.abspath(myDir), myID, myID+'.msg.xml')
        elif (type == 'params'):
            myDir   = myServiceDir 
            myFile  = os.path.join(os.path.abspath(myDir), myID, myID+'.params.xml')
        elif (type == 't') or (type == 'cpp'):
            myDir   = myServiceDir 
            myFile  = os.path.join(os.path.abspath(myDir), myID, myID+'.cpa-template.xml')
        elif type == 'p':
            myDir   = myParticipantDir 
            myFile  = os.path.join(os.path.abspath(myDir), myID, myID+'.parameters.xml')
        elif type == 'd':
            myDir   = myDownloadDir
            if miniForm.has_key('refFolder'):
                refFolder = miniForm['refFolder'][0]
            if miniForm.has_key('refFile'):
                refFile = miniForm['refFile'][0]
            myFile  = os.path.join(os.path.abspath(myDir), refFolder, refFile)
            
            header = "Pragma: public;Expires: 0;Cache-Control: must-revalidate, post-check=0, pre-check=0;Content-Type: application/force-download;Content-Type: application/octet-stream;Content-Type: application/download;Content-Disposition: attachment; filename="+str(refFile)+";Content-Transfer-Encoding: binary;"
        else:
            print "Content-type: text/html\n" # Do this first
            print """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><HTML><HEAD><TITLE>CPA Creation Toolkit - Version 4.0</TITLE>"""
            print """<link rel="stylesheet" title="CPA Creation Toolkit" type="text/css" media="screen" href="/table-in-css.css"></HEAD><BODY>"""
            myString = "Unrecognized cmd type "+str(type)+"<BR>"
            if not html_fallback.has_key(language):
                language = u'en'
            myString = html_fallback[language].replace("__NOTIFICATION_PH__", myString)
            print myString
            print "</BODY></HMTL>"
            return
        
        try:
            msgContents = utilities.getFile(myFile)
            if msgContents == "":
                print "Content-type: text/html\n" # Do this first
                print """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><HTML><HEAD><TITLE>CPA Creation Toolkit - Version 4.0</TITLE>"""
                print """<link rel="stylesheet" title="CPA Creation Toolkit" type="text/css" media="screen" href="/table-in-css.css"></HEAD><BODY>"""
                if myID == "":
                    myString = message[(language,u'noID')]
                else:
                    myString = message[(language,u'noINFO')]+myID+"<BR>"
                if not html_fallback.has_key(language):
                    language = u'en'
                myString = html_fallback[language].replace("__NOTIFICATION_PH__", myString)
                print myString
                print "</BODY></HMTL>"
                return
        except:
            print "Content-type: text/html\n" # Do this first
            print """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><HTML><HEAD><TITLE>CPA Creation Toolkit - Version 4.0</TITLE>"""
            print """<link rel="stylesheet" title="CPA Creation Toolkit" type="text/css" media="screen" href="/table-in-css.css"></HEAD><BODY>"""
            myString = message[(language,u'processing')] + myID + " and/or file " + myFile + "<BR>"
            if not html_fallback.has_key(language):
                language = u'en'
            myString = html_fallback[language].replace("__NOTIFICATION_PH__", myString)
            print myString
            cgi.print_exception()
            print "</BODY></HMTL>"
            return
        #============================================================
        # Well, well, we have found the xml data: print it.
        print header
        print str(msgContents)
        return
    except:
        print "Content-type: text/html\n" # Do this first
        print """<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><HTML><HEAD><TITLE>CPA Creation Toolkit - Version 4.0</TITLE>"""
        print """<link rel="stylesheet" title="CPA Creation Toolkit" type="text/css" media="screen" href="/table-in-css.css"></HEAD><BODY>"""
        if not html_fallback.has_key(language):
            language = u'en'
        myString = html_fallback[language].replace("__NOTIFICATION_PH__", str(sys.exc_info()[1]))
        print myString
        cgi.print_exception()
        print "</BODY></HMTL>"
        return
main()