#!"..\Python\App\python.exe" -u

"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import cgi
import os, sys, string
import utilities
import myProperties
import messages

html_fallback = {
u'nl' : """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<html><head>
<title>CPA Creatie Toolkit - Oops... er zijn fouten opgetreden</title>
<link rel="stylesheet" title="CpaToolkit default" type="text/css" media="screen" href="/table-in-css.css">
</head>
<body>
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creatie</h2>
<h1>Oops... er zijn fouten opgetreden</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Service Specificatie</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Er zijn fouten geconstateerd in de configuratie van de CPA Creatie Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
</body>
</html>
""",
u'en' : """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<html><head>
<title>CPA Creation Toolkit - Oops... an error has occurred!</title>
<link rel="stylesheet" title="CpaToolkit default" type="text/css" media="screen" href="/table-in-css.css">
</head>
<body>
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creation</h2>
<h1>Oops... an error has occurred!</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Service Specificatie</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Errors have been identified in the configuration of the CPA Creation Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
</body>
</html>
"""
}

def _(id, language):
    return messages.Translation(id, language)

def main(notification=None, language=None):
    try:
        miniForm = cgi.FormContent()
        profile  = '1'  # Default profile in the repository
        if miniForm.has_key('profile'):
            value = miniForm['profile'][0]
            if value in ['1', '2', '3', '4']:
                profile = value
        #
        if not language:
            language  = u'en'  # Default language
            if miniForm.has_key('language'):
                value = miniForm['language'][0][0:2]
                if value in [u'nl',u'en']:
                    language = value
        else:
            if not (language in [u'nl',u'en']):
                language  = u'en'  # Default language
        #
        config = myProperties.Properties(language)
        if (config.error):
            myError = "ERROR getServiceId.py; Could not initialize.<BR>"
            myError = myError + config.error + "<BR>"
            myString = html_fallback[language] 
            myString = myString.replace('__NOTIFICATION_PH__', myError)
            print myString
            return
        #
        if not config.ToolkitPath:
            if notification:
                notification = notification + "<BR>" + utilities.redHtmlFormat(_(79,language))
            else:
                notification = utilities.redHtmlFormat(_(79,language))
        
        if config.ToolkitPath:
            myServiceDir                = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'c'))
            myParticipantDir            = os.path.abspath(os.path.join(config.ToolkitPath, profile, 'p'))
        else:
            myServiceDir                = None
            myParticipantDir            = None

        myFile      = os.path.join(config.HTMLResultTemplate, 'id','stap1.html')
        if not os.path.exists(myFile):
            myError = "ERROR getServiceId.py; The html file in the html-template folder does not exist:<BR>"+myFile+"<BR>Please check the configuration.<BR>"
            myString = html_fallback[language] 
            myString = myString.replace('__NOTIFICATION_PH__', myError)
            print myString
            return
        #
        filePath=os.path.join(myFile)
        try:
            f = open(filePath,'rb')
        except:
            myError  = myError + "ERROR getServiceId.py; Could not read the html file in the html-template folder.<BR>"+str(sys.exc_info()[1])+"<BR>Please check the configuration.<BR>"
            myString = html_fallback[language] 
            myString = myString.replace('__NOTIFICATION_PH__', myError)
            print myString
            return
            
        myString = f.read(-1)
        f.close()

        myDir = myServiceDir
        if myDir and (not os.path.exists(myDir)):
            if notification:
                notification = notification + "<BR>" + utilities.redHtmlFormat(_(79,language))
            else:
                notification = utilities.redHtmlFormat(_(79,language))

        dirnames = utilities.getDirectoryList(myDir)
        myCollaborationList = utilities.makeListFromTemplate(dirnames, "<OPTION VALUE=\"__PH__\">__PH__","__PH__")
        myTemplate  = "<!--__OPTION_VALUE_SPEC_PH__-->"
        myString = myString.replace(myTemplate, myCollaborationList)
        if notification:
            myString = myString.replace('__NOTIFICATION_PH__', notification)
        else:
            myString = myString.replace('__NOTIFICATION_PH__', "")
        myString = myString.replace('__PH_PROFILE__',profile)
        print myString
        return True
    except:
        if language:
            myString = html_fallback[language]
        else:
            myString = html_fallback[u'en']
        myString = myString.replace('__NOTIFICATION_PH__', str(sys.exc_info()[1]))
        print myString
        #cgi.print_exception()
        return False
    
if __name__ == '__main__':
    print "Content-type: text/html\n" # Do this first
    main()