"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import cgi
import cgitb; cgitb.enable()
import os, sys, string
import uuid
import shutil
import keyinfoWriter
import utilities
import myProperties
import messages

html_fallback = {
u'nl' : """
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creatie</h2>
<h1>Oops... er zijn fouten opgetreden</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Foutmeldingen</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Er zijn fouten geconstateerd in de configuratie van de CPA Creatie Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
""",
u'en' : """
<!--
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
-->
<div class="base-layer">
<table summary="" border="0" align="center" cellpadding="10" cellspacing="10" width="100%">
<tr>
<td align="left">
<p align="left"><a onClick="history.go(-1);return true;"><img src="/cpa/4/0/logo40.png" height="100" border=0></a></p>
</td>
<td align="right">
<h2>CPA Creation</h2>
<h1>Oops... an error has occurred!</h1>
</td>
</tr>
</table>
<div class = "table-row"><strong>Error messages</strong></div>
<div class = "table-row2">
<div class=left-container2>&nbsp;</div><div class=right-container2>Errors have been identified in the configuration of the CPA Creation Toolkit.</div>
</div>
<div class = "space-line">&nbsp;</div>
<center><strong>__NOTIFICATION_PH__</strong></center>
<div class = "space-line">&nbsp;</div>
</div>
"""
}

def _(id, language):
    return messages.Translation(id, language)

def main():
    form = cgi.FieldStorage()
    #
    language = u'en' # Default
    if (form.has_key('language') and form['language'].value != ""):
        value = (form['language'].value)[0:2]
        if value in [u'nl',u'en']:
            language = value
    #
    config = myProperties.Properties()
    if (config.error):
        myError = "ERROR keyinfoworker.py; Could not initialize, reading property file.<BR>"
        myError = myError + config.error + "<BR>"
        myString = html_fallback[language].replace("__NOTIFICATION_PH__", myError)
        print myString
        return

    myPropertyToolkitFilePath  = config.ToolkitPath
    myJava = os.path.join(myPropertyToolkitFilePath,config.repository['java'])

    # Set the proper language and file path/url
    config.setLanguage(language)
    htmlBaseUrl = config.HTMLBaseUrl
    
    apacheUrl = config.Url
    uploadDir = config.UploadDir
    resultFilePath = os.path.join(config.HTMLResultTemplate,'keyinfo')
    apacheDir = config.htdocs
    uniqueid = str(uuid.uuid1())
    upload_dir= os.path.join(uploadDir,uniqueid)
    download_dir=os.path.join(config.DownloadDir,uniqueid)

    myCert  = ""
    error   = ""
    link    = ""

    Executer = utilities.Executer(os.path.abspath(myPropertyToolkitFilePath))

    try:
        if not os.path.exists(download_dir):
            os.mkdir(download_dir)

        if form.has_key("cert") and form["cert"].filename != "":
            messages = form["cert"]
            myCert = form["cert"].filename

            #----------------------------------
            # MS *NIX IE en FIREFOR crazyness    
            index1 = myCert.rfind('/')
            index2 = myCert.rfind('\\')
            index = 0
            if index1 > -1:
                index = index1+1
            if index2 > -1:
                index = index2+1
            myCert=myCert[index:]
            #print myCert.strip(os.sep), index1, index2, myCert[index+1:]
            #----------------------------------
            
            if messages.file:
                # fileMsg = form["FileMsg"].file.read()
                # print "<h1>Hello FileMsg</h1>" #, cgi.escape(fileMsg)
                if not os.path.isdir(upload_dir):
                    os.mkdir(upload_dir)
                filePath= os.path.join(upload_dir, myCert)
                messagesfout = file (filePath, 'wb')
                while 1:
                    chunk = messages.file.read(100000)
                    if not chunk: break
                    messagesfout.write (chunk)
                messagesfout.close()
            else:
                error = error + utilities.redHtmlFormat(_(80,config.Language))+"<BR>"
                
        else:
            error = error + utilities.redHtmlFormat(_(81,config.Language))+"<BR>"
    except:
        error = error + utilities.redHtmlFormat(_(82,config.Language))+"<BR>"

    if not error:
        try:
            keyinfoFilePath= os.path.join(download_dir, myCert+'.keyinfo.xml')
            myWriter = keyinfoWriter.KeyInfoWriter(Executer, myJava, myPropertyToolkitFilePath)
            myWriter.Write(filePath,keyinfoFilePath)
            if os.path.exists(keyinfoFilePath):
                #shutil.copy(keyinfoFilePath, download_dir)
                link = "<a href=\""+apacheUrl+"/downloads/"+uniqueid+"/"+myCert+(".keyinfo.xml\" target=\"_Blank\">%s.keyinfo.xml</a>"%myCert)
            else:
                error = error + utilities.redHtmlFormat(_(83,config.Language))+"<BR>"
        except:
            error = error + utilities.redHtmlFormat(_(84,config.Language))+"<BR>"
        
    filePath=os.path.join(resultFilePath,'result.html')
    f = open(filePath,'rb')
    resultPage = f.read(-1)
    f.close()

    resultPage = resultPage.replace('__CERTFILE_PH__', myCert)
    resultPage = resultPage.replace('__LINK_PH__', link)
    if error:
        error = "<p><strong>"+_(85,config.Language)+"</strong></p><p>"+error+"</p>"
    resultPage = resultPage.replace('__ERROR_PH__', error)

    print resultPage

main()    