"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import os, sys
import string

# A very simple way to deal with messages in different languages...

myNumberOfLanguages = 2                 # Adjust to the number of languages!!
myLanguages         = [u'nl', u'en']    # See property.properties file as well!!

myMessages          = {
    (1,u'en')   : u'(There is no e-mail server configured. You will not be notified via e-mail.)',
    (1,u'nl')   : u'(Er is geen e-mail server ingesteld. U wordt niet op de hoogte gehouden via e-mail.)',
    (2,u'en')   : u'Notifications will be sent via e-mail.',
    (2,u'nl')   : u'Er worden notificaties verstuurd via e-mail.',
    (3,u'en')   : u'Warning: could not inform the Service Specifier via e-mail.',
    (3,u'nl')   : u'Waarschuwing: kon de Service Specifier niet informeren via e-mail.',
    (4,u'en')   : u'Warning: could not inform the Specifier via e-mail.',
    (4,u'nl')   : u'Waarschuwing: kon de Specifier niet informeren via e-mail.',
    (5,u'en')   : u'Warning: could not inform the Participant via e-mail.',
    (5,u'nl')   : u'Waarschuwing: kon de Participant niet informeren via e-mail.',
    (6,u'en')   : u'Warning: could not inform the Service Requester and/or Service Provider via e-mail.',
    (6,u'nl')   : u'Waarschuwing: kon de Service Requester en/of Service Provider niet informeren via e-mail.',
    (7,u'en')   : u'Failed to create the CPA. Likely not all parameters were provided (as the Service specifies).',
    (7,u'nl')   : u'Faalde in het maken van de CPA. Waarschijnlijk waren niet alle parameters bijgeleverd (zoals de Service specificeert).',
    (8,u'en')   : u'FAILED.',
    (8,u'nl')   : u'GEFAALD.',
    (9,u'en')   : u'CPA Creatio Toolkit - CPA Specification stored by Service Provider.',
    (9,u'nl')   : u'CPA Creatie Toolkit - CPA Specificatie opgeslagen door Service Aanbieder.',
    (10,u'en')  : u'CPA Creation Toolkit - CPA Requested by Service Requester.',
    (10,u'nl')  : u'CPA Creatie Toolkit - CPA Aangevraagd door Service Afnemer.',
    (11,u'en')  : u'CPA Creation Toolkit - CPA Created.',
    (11,u'nl')  : u'CPA Creatie Toolkit - CPA Gecreeerd.',
    (12,u'en')  : u'CPA Creation Toolkit - CPA Created for Justitie Acceptatie Test',
    (12,u'nl')  : u'"CPA Creatie Toolkit - CPA Gecreeerd voor Justitie Acceptatie Test.',
    (13,u'en')  : u'CPA Creation Toolkit - Service Specification stored.',
    (13,u'nl')  : u'CPA Creatie Toolkit - Service Specificatie opgeslagen.',
    (14,u'en')  : u'CPA Creation Toolkit - Participant Specification stored.',
    (14,u'nl')  : u'CPA Creatie Toolkit - Participant specificatie opgeslagen.',
    (15,u'en')  : u'CPA Creation Toolkit - Notification: errors have occured; the formType is unknown.',
    (15,u'nl')  : u'CPA Creatie Toolkit - Notificatie: er zijn fouten opgetreden; het formType is niet bekend.',
    (16,u'en')  : u'Input file does not exist.',
    (16,u'nl')  : u'Invoer bestand bestaat niet.',
    (17,u'en')  : u'The fileDrop folder did not exist; it has been created!<BR>Look into: ',
    (17,u'nl')  : u'De fileDrop folder bestond nog niet; deze is aangemaakt!<BR>Kijk in: ',
    (18,u'en')  : u'The inputfile has not been provided!',
    (18,u'nl')  : u'Er is geen inputbestand opgegeven!',
    (19,u'en')  : u'Error! Could not read xml file.',
    (19,u'nl')  : u'Fout! Kon het xml bestand niet lezen.',
    (20,u'en')  : u'Error! The local AutoImport-folder does not exist: ',
    (20,u'nl')  : u'Fout! De lokale AutoImport-folder bestaat niet: ',
    (21,u'en')  : u'Error! The AutoImport-folder of the other party does not exist: ',
    (21,u'nl')  : u'Fout! De AutoImport-folder van de andere partij bestaat niet: ',
    (22,u'en')  : u'Error! The CPA has been rejected after it has been put into the AutoImport-folder!',
    (22,u'nl')  : u'Fout! De CPA is afgekeurd nadat het in de AutoImport folder is geplaatst!',
    (23,u'en')  : u'Error! The CPA has been rejected after it has been put into the AutoImport-folder of the other party!',
    (23,u'nl')  : u'Fout! De CPA is afgekeurd nadat het in de AutoImport folder is geplaatst van de andere partij!',
    (24,u'en')  : u'Could not process the xml file.',
    (24,u'nl')  : u'Kon het xml bestand niet verwerken.',
    (25,u'en')  : u'The result is an empty file. Maybe an incorrect input file (type) has been provided.',
    (25,u'nl')  : u'Het resultaat is een leeg bestand. Misschien is er een verkeerd bestand (type) opgegeven.',
    (26,u'en')  : u'Could not transform the CPA.',
    (26,u'nl')  : u'Kon de CPA niet transformeren.',
    (27,u'en')  : u'An unknown form type has been provided.',
    (27,u'nl')  : u'Er is een onbekend formulier type opgegeven.',
    (28,u'en')  : u'Provide a valid form type.',
    (28,u'nl')  : u'Geef een geldig formulier type op.',
    (29,u'en')  : u'An unknown specification type has been provided.',
    (29,u'nl')  : u'Er is een onbekend specificatie type opgegeven.',
    (30,u'en')  : u'Provide a valid specification type.',
    (30,u'nl')  : u'Geef een geldig specificatie type op.',
    (31,u'en')  : u'An unknown profile has been provided.',
    (31,u'nl')  : u'Er is een onbekend profiel opgegeven.',
    (32,u'en')  : u'Provide a valid profile name.',
    (32,u'nl')  : u'Geef een geldig profiel naam.',
    (33,u'en')  : u'An invalid ID has been provided.',
    (33,u'nl')  : u'Er is een ongeldige ID opgegeven.',
    (34,u'en')  : u'Provide a valid ID.',
    (34,u'nl')  : u'Geef een geldige ID op.',
    (35,u'en')  : u'Provide a valid version number.',
    (35,u'nl')  : u'Geef een geldig versienummer op.',
    (36,u'en')  : u'Invalid start date.',
    (36,u'nl')  : u'Ongeldige start datum.',
    (37,u'en')  : u'Invalid end date.',
    (37,u'nl')  : u'Ongeldige eind datum.',
    (38,u'en')  : u'The rolename of party A could not be derived from the filename.',
    (38,u'nl')  : u'De rolnaam van partij A kon niet worden afgeleid uit de bestandsnaam.',
    (39,u'en')  : u'The rolename contains invalid characters.',
    (39,u'nl')  : u'De rolnaam bevat ongeldige karakters.',
    (40,u'en')  : u'The rolename of party A is missing.',
    (40,u'nl')  : u'De rolnaam van de partij A ontbreekt.',
    (41,u'en')  : u'The rolename of party B could not be derived from the filename.',
    (41,u'nl')  : u'De rolnaam van partij B kon niet worden afgeleid uit de bestandsnaam.',
    (42,u'en')  : u'The rolename of party B is missing.',
    (42,u'nl')  : u'De rolnaam van de partij B ontbreekt.',
    (43,u'en')  : u'ID for party A not specified.',
    (43,u'nl')  : u'ID voor partij A is niet gespecificeerd.',
    (44,u'en')  : u'ID for party B not specified',
    (44,u'nl')  : u'ID voor partij B is niet gespecificeerd.',
    (45,u'en')  : u'Invalid name provided.',
    (45,u'nl')  : u'Ongeldige naam opgegeven.',
    (46,u'en')  : u'The name is not provided.',
    (46,u'nl')  : u'Er is geen naam opgegeven.',
    (47,u'en')  : u'Invalid e-mail address provided.',
    (47,u'nl')  : u'Ongeldig e-mail adres opgegeven.',
    (48,u'en')  : u'The e-mail address is not provided.',
    (48,u'nl')  : u'Er is geen e-mail adres opgegeven.',
    (49,u'en')  : u'Error reading specification file.',
    (49,u'nl')  : u'Fouten bij het lezen van het specificatie bestand.',
    (50,u'en')  : u'The input file (...parameters.xml) of party A could not be read.',
    (50,u'nl')  : u'Het input bestand (...parameters.xml) van partij A kon niet worden gelezen.',
    (51,u'en')  : u'The form has no input field ID.parameters.RoleA.xml.',
    (51,u'nl')  : u'Het formulier heeft geen input veld ID.parameters.RolA.xml.',
    (52,u'en')  : u'Error reading ID or ID.parameters.RoleA.xml file.',
    (52,u'nl')  : u'Fouten bij het lezen van ID of ID.parameters.RolA.xml bestand.',
    (53,u'en')  : u'Provide an other ID for the participant.',
    (53,u'nl')  : u'Geef een andere ID op voor de participant.',
    (54,u'en')  : u'Provide an ID of the participant.',
    (54,u'nl')  : u'Geef een ID van de participant.',
    (55,u'en')  : u'Error reading the participant file.',
    (55,u'nl')  : u'Fouten bij het lezen van het participanten bestand.',
    (56,u'en')  : u'The input file (...parameters.xml) of party B could not be read.',
    (56,u'nl')  : u'De input file (...parameters.xml) van Partij B kon niet gelezen worden.',
    (57,u'en')  : u'Error reading ID or ID.parameters.RoleB.xml file.',
    (57,u'nl')  : u'Fouten bij het lezen van ID of ID.parameters.RolB.xml bestand.',
    (58,u'en')  : u'The form has no input field ID.parameters.RoleB.xml.',
    (58,u'nl')  : u'Het formulier heeft geen input veld ID.parameters.RolB.xml.',
    (59,u'en')  : u'An unknown connection type has been provided.',
    (59,u'nl')  : u'Er is een onbekend koppeling type opgegeven.',
    (60,u'en')  : u'Provide a valid connection type.',
    (60,u'nl')  : u'Geef een geldig koppeling type op.',
    (61,u'en')  : u'An unexpected error occurred during the processing of the webform.',
    (61,u'nl')  : u'Er is een onbekend fout opgetreden tijdens de verwerking van het webformulier.',
    (62,u'en')  : u'No participant found for the role: ',
    (62,u'nl')  : u'Geen participant gevonden voor de rol: ',
    (63,u'en')  : u'There are too little participants provided (at least two must be provided).',
    (63,u'nl')  : u'Er zijn te weinig participanten opgegeven (er moeten er minimaal twee worden opgegeven).',
    (64,u'en')  : u'The field contains invalid characters. Allowed are numbers, letters and the characters . - or _',
    (64,u'nl')  : u'Het veld bevat ongeldige karakters. Toegestaan zijn cijfers, letters en de karakters . - of _',
    (65,u'en')  : u'The e-mail address contains invalid characters. Allowed are numbers, letters and the characters . - + _ or @',
    (65,u'nl')  : u'Het e-mail adres bevat ongeldige karakters. Toegestaan zijn cijfers, letters en de karakters . - + _ of @',
    (66,u'en')  : u'The date contains invalid characters. Format CCYY-MM-DD',
    (66,u'nl')  : u'De datum bevat ongeldige karakters. Formaat EEJJ-MM-DD',
    (67,u'en')  : u'The date is invalid. Format CCYY-MM-DD',
    (67,u'nl')  : u'De datum is ongeldig. Formaat EEJJ-MM-DD',
    (68,u'en')  : u'The input file was too large.',
    (68,u'nl')  : u'De input file was te groot.',
    (69,u'en')  : u'The input file could not be read.',
    (69,u'nl')  : u'Het input bestand kon niet worden gelezen.',
    (70,u'en')  : u'Errors occurred during the input validation (see below).',
    (70,u'nl')  : u'Er zijn fouten opgetreden bij de invoer validatie (zie hieronder).',
    (71,u'en')  : u'The input file could not be processed.',
    (71,u'nl')  : u'Het input bestand kon niet worden verwerkt.',
    (72,u'en')  : u'Provided ID is unknown.',
    (72,u'nl')  : u'Opgegeven ID is niet bekend.',
    (73,u'en')  : u'Provided ID could not be created.',
    (73,u'nl')  : u'Opgegeven ID kon niet gemaakt worden.',
    (74,u'en')  : u'The Service Specification is not valid.',
    (74,u'nl')  : u'De service specificatie is niet valide.',
    (75,u'en')  : u'Incorrect roles. Expected versus Provided: ',
    (75,u'nl')  : u'Onjuiste rollen. Verwacht versus Opgegeven: ',
    (76,u'en')  : u'Provided ID is unknown for party: ',
    (76,u'nl')  : u'Opgegeven ID is onbekend voor partij: ',
    (77,u'en')  : u'Unknown participant for the role: ',
    (77,u'nl')  : u'Onbekende participant voor de rol: ',
    (78,u'en')  : u'The rolenames are incorrect.',
    (78,u'nl')  : u'De rolnamen zijn niet juist.',
    (79,u'en')  : u'The root-folder of the repository is not correct.',
    (79,u'nl')  : u'De root-folder van de repositorie is niet correct.',
    (80,u'en')  : u'The certificate could not be read.',
    (80,u'nl')  : u'Het certificaat kon niet inlezen worden.',
    (81,u'en')  : u'Provide a certificate!',
    (81,u'nl')  : u'Geef een certificaat op!',
    (82,u'en')  : u'Could not process the certificate (is the format correct?).',
    (82,u'nl')  : u'Kon het certificaat niet verwerken (is het formaat juist?).',
    (83,u'en')  : u'The input file is not correct.',
    (83,u'nl')  : u'Het input bestand is niet correct.',
    (84,u'en')  : u'Could not read the certificate.',
    (84,u'nl')  : u'Kon het certificaat niet inlezen.',
    (85,u'en')  : u'The KeyInfo could not be created due to some errors.',
    (85,u'nl')  : u'De KeyInfo kon niet worden gemaakt omdat er fouten zijn opgetreden.',
    (86,u'en')  : u'Errors have occurred during the creation of CPA\'s; this resulted into empty file(s).',
    (86,u'nl')  : u'Er zijn fouten opgetreden bij het creeren van CPA\'s; dit resulteerde in lege bestanden.',
    (87,u'en')  : u'The selected roles are not part of a collaboration; there is no CPA created.',
    (87,u'nl')  : u'De geselecteerde rollen zijn geen onderdeel van een samenwerking; er is geen CPA gemaakt.',
    }

myMessageCount      = len(myMessages) / myNumberOfLanguages   # Range between 1..myMessageCount

def Translation(id, language=None):
    # Return the string, belonging by the identifier id for the specified langauge
    if (id > 0) and (id < (myMessageCount+1)):
        if not language:
            return myMessages[(id,u'en')]           # Default language
        else:
            if language in myLanguages:
                return myMessages[(id,language)]
            else:
                return myMessages[(id,u'en')]       # Default language
    return None

if __name__ == '__main__':
    print "Number of languages: ",myNumberOfLanguages
    print "Languages: ",myLanguages
    print "Message (1,en): ", message(1, u'en')
    print "Message (2,en): ", message(2, u'en')
    print "Message (1,nl): ", message(1, u'nl')
    print "Message (2,nl): ", message(2, u'nl')
    print "Message (2,pl): ", message(2, u'pl')
    print "Message (1,pl): ", message(1, u'pl')
    print "Message (12,nl): ", message(12, u'nl')
    print "Message (2): ", message(2)
    print "DONE"
