"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import cgi
import cgitb; cgitb.enable()
import os, sys
import uuid
import shutil
import utilities
import keyinfoWriter
import myProperties

def removeXMLheading(string):
   return string.replace(u'<?xml version="1.0" encoding="UTF-8"?>','')

class CreateWorker:
    def __init__(self):
        self.status = True
        self.errormessage = ""
        
        config = myProperties.Properties()
        self.config = config
        if (config.error):
            self.errormessage = "ERROR parametersworker.py; Could not initialize, reading property file.<BR>" + config.error + "<BR>"
            self.status = False
            return

        self.form           = ""
        apacheDir           = config.htdocs
        apacheUrl           = config.Url
        uploadDir           = config.UploadDir
        downloadDir         = config.DownloadDir
        downloadUrl         = config.DownloadUrl
        uniqueid            = str(uuid.uuid1())
        self.uniqueid       = uniqueid
        self.cpaAutoImport  = None

        myPropertyToolkitFilePath  = config.ToolkitPath
        self.toolkitroot = myPropertyToolkitFilePath
        self.myJava = os.path.join(myPropertyToolkitFilePath,config.repository['java'])

        """
        Prepare directories and url
        """
        self.resultFilePath = "" # Depends on the language config.HTMLResultTemplate
        self.htmlBaseUrl    = "" # Depends on the language config.HTMLBaseUrl 
        self.upload_dir     = os.path.join(uploadDir,uniqueid)
        self.download_dir   = os.path.join(downloadDir,uniqueid)
        self.download_url   = downloadUrl + '/' + uniqueid + '/'
        self.formType       = 'participant'
        self.myCpaForm      = None
        self.refID          = None
        self.notification   = None
        self.SMTPServer     = config.SMTPServer
        self.myEmail        = config.emailCpaManager
        self.xml            = ""
        self.notification   = ""
        self.link           = "Show/Download Message"
        self.Executer       = utilities.Executer(os.path.abspath(myPropertyToolkitFilePath))
        self.partyId        = config.defaultPartyId
        self.partyIdType    = config.defaultPartyIdType
        if self.partyId == "":
            self.partyId = None
        self.intermediary   = config.defaultIntermediary
        if self.intermediary == "":
            self.intermediary = None

        if not os.path.exists(self.upload_dir):
            os.mkdir(self.upload_dir)
        if not os.path.exists(self.download_dir):
            os.mkdir(self.download_dir)

    def PrepareErrorPages(self):

        """
        Prepare ERROR html page
        """
        filePath=os.path.join(self.config.HTMLResultTemplate,self.formType,'error2.html')
        f = open(filePath,'rb')
        dataHEAD = f.read(-1)
        f.close()

        dataHEAD = dataHEAD.replace('__XMLINPUT_PH__', self.xml)
        dataHEAD = dataHEAD.replace('__NOTIFICATION_PH__', self.notification)
        dataHEAD = dataHEAD.replace('__ERR_PH__',self.errormessage+'__ERR_PH__')

        self.dataERR = dataHEAD
        return

    def Presentation(self):
        """
        Present Resultpage
        """
        filePath=os.path.join(self.config.HTMLResultTemplate,self.formType,'result2.html')
        f = open(filePath,'rb')
        dataHEAD = f.read(-1)
        f.close()

        dataHEAD = dataHEAD.replace('__XMLINPUT_PH__', self.xml)
        dataHEAD = dataHEAD.replace('__DOWNLOADURL_PH__', self.download_url)
        dataHEAD = dataHEAD.replace('__NOTIFICATION_PH__', self.notification)

        print dataHEAD

    def getKeyValue(self, key):
        if self.form.has_key(key) and self.form[key].value != "":
            return self.form[key].value
        else:
            return None

    def getKeyFile(self, key, upload_dir):
        status = False
        if self.form.has_key(key) and self.form[key].value != "":
            myfile = self.form[key]
            filename = self.form[key].filename
            #----------------------------------
            # MS *NIX IE en FIREFOR crazyness    
            index1 = filename.rfind('/')
            index2 = filename.rfind('\\')
            index = 0
            if index1 > -1:
                index = index1+1
            if index2 > -1:
                index = index2+1
            myFilename=filename[index:]
            #----------------------------------
            try:
                if myfile.file:
                    if not os.path.isdir(upload_dir):
                        os.mkdir(upload_dir)
                    filePath= os.path.join(upload_dir, myFilename)
                    fout = file (filePath, 'wb')
                    while 1:
                        chunk = myfile.file.read(100000)
                        if not chunk: break
                        fout.write (chunk)
                    fout.close()
                    status = True
                else:
                    status = False
            except:
                status = False
        if status:
            return filePath
        else:
            return None
        
    def ProcessForm(self):
        encrCert = None
        signCert = None
        clientCert = None
        serverCert = None
        csvFile    = None

        self.status = True
        self.errormessage = ""
        form = cgi.FieldStorage()
        self.form = form

        language = self.getKeyValue('language')
        # Set the proper language and file path/url
        self.config.setLanguage(language)
        self.resultFilePath = self.config.ResultTemplateDir
        self.htmlBaseUrl    = self.config.HTMLBaseUrl

        # Prepare error page
        self.PrepareErrorPages()
        
        #                
        persoonsnaam = self.getKeyValue('Persoonsnaam')
        if not persoonsnaam:
            persoonsnaam = "Persoonsnaam_PH"
        #
        email = self.getKeyValue('Email')
        if not email:
            email = "Email_PH"
        #
        telefoon = self.getKeyValue('Telefoon')
        if not telefoon:
            telefoon = "Telefoon_PH"
        #
        partyid = self.getKeyValue('PartyId')
        if not partyid:
            if self.partyId:
               partyid = self.partyId
            else:
               partyid = "PartyId_PH"
        #
        partyidtype = self.getKeyValue('PartyIdType')
        if not partyidtype:
            if self.partyIdType:
               partyidtype = self.partyIdType
            else:
               partyidtype = "PartyIdType_PH"
        #
        partyname = self.getKeyValue('PartyName')
        if not partyname:
            partyname = "PartyName_PH"
        #
        partyref = self.getKeyValue('PartyRef')
        if not partyref:
            partyref = "PartyRef_PH"
        #
        localendpoint = self.getKeyValue('LocalEndpoint')
        if not localendpoint:
            localendpoint = "LocalEndpointUri_PH"
        #
        endpoint = self.getKeyValue('Endpoint')
        if not endpoint:
            if self.intermediary:
                endpoint = self.intermediary
            else:
                endpoint = "NearestEndpointUri_PH"

        encrCert = self.getKeyFile('EncryptionCert',self.upload_dir)
        signCert = self.getKeyFile('SigingCert',self.upload_dir)
        clientCert = self.getKeyFile('ClientCert',self.upload_dir)
        serverCert = self.getKeyFile('ServerCert',self.upload_dir)
        csvFile  = self.getKeyFile('PartyIdList',self.upload_dir)

        # Check for received message id
        if not self.status:
            self.dataERR = self.dataERR.replace('__ERR_PH__', self.errormessage)
            print self.dataERR
            return True
        else:
            parametersFilename = partyid+'.ANYROLE.parameters.xml'
            downloadFile = os.path.join(self.download_dir,parametersFilename)
            #print messageFilePath,"<BR>"

            xmlTemplateFile = os.path.join(self.resultFilePath, 'template.ANYROLE.parameters.xml')
            myFileContents = utilities.getFile(xmlTemplateFile)
            if not myFileContents == "":
                if persoonsnaam:
                    myFileContents = myFileContents.replace("Persoonsnaam_PH",persoonsnaam)
                if email:
                    myFileContents = myFileContents.replace("Email_PH",email)
                if telefoon:
                    myFileContents = myFileContents.replace("Telefoon_PH",telefoon)
                if partyid:
                    myFileContents = myFileContents.replace("PartyId_PH",partyid)
                if not csvFile:
                    myFileContents = myFileContents.replace("PartyIdList_PH",'<value>'+partyid+'</value>')
                else:
                    myPartyListFile = utilities.getFile(csvFile)
                    if not myPartyListFile == "":
                        myPartyList = myPartyListFile.split(',')
                        firstPartyId = myPartyList[0]
                        myFileContents = myFileContents.replace("PartyId_PH",firstPartyId)
                        valueList = ""
                        for partyId in myPartyList:
                            valueList = valueList + '<value>'+partyId+'</value>'
                        myFileContents = myFileContents.replace("PartyIdList_PH",valueList)
                    else:
                        self.errormessage = self.errormessage + "Could not read .csv file"
                        self.download_url = ''
                        self.status = False
                if partyname:
                    myFileContents = myFileContents.replace("PartyName_PH",partyname)
                if partyref:
                    myFileContents = myFileContents.replace("PartyRef_PH",partyref)
                if partyidtype:
                    myFileContents = myFileContents.replace("PartyIdType_PH",partyidtype)
                if localendpoint:
                    myFileContents = myFileContents.replace("LocalEndpoint_PH",localendpoint)
                if endpoint:
                    myFileContents = myFileContents.replace("NearestEndpoint_PH",endpoint)
                if encrCert:
                    keyinfoFilePath= os.path.join(self.download_dir, 'encrCert.keyinfo.xml')
                    myWriter = keyinfoWriter.KeyInfoWriter(self.Executer, self.myJava, self.toolkitroot)
                    myWriter.Write(encrCert,keyinfoFilePath)
                    if os.path.exists(keyinfoFilePath):
                        keyInfo = utilities.getFile(keyinfoFilePath)
                        myFileContents = myFileContents.replace("EncrCert_PH",removeXMLheading(keyInfo))
                if signCert:
                    keyinfoFilePath= os.path.join(self.download_dir, 'signCert.keyinfo.xml')
                    myWriter = keyinfoWriter.KeyInfoWriter(self.Executer, self.myJava, self.toolkitroot)
                    myWriter.Write(signCert,keyinfoFilePath)
                    if os.path.exists(keyinfoFilePath):
                        keyInfo = utilities.getFile(keyinfoFilePath)
                        myFileContents = myFileContents.replace("SignCert_PH",removeXMLheading(keyInfo))
                if clientCert:
                    keyinfoFilePath= os.path.join(self.download_dir, 'clientCert.keyinfo.xml')
                    myWriter = keyinfoWriter.KeyInfoWriter(self.Executer, self.myJava, self.toolkitroot)
                    myWriter.Write(clientCert,keyinfoFilePath)
                    if os.path.exists(keyinfoFilePath):
                        keyInfo = utilities.getFile(keyinfoFilePath)
                        myFileContents = myFileContents.replace("ClientCert_PH",removeXMLheading(keyInfo))
                if serverCert:
                    keyinfoFilePath= os.path.join(self.download_dir, 'serverCert.keyinfo.xml')
                    myWriter = keyinfoWriter.KeyInfoWriter(self.Executer, self.myJava, self.toolkitroot)
                    myWriter.Write(serverCert,keyinfoFilePath)
                    if os.path.exists(keyinfoFilePath):
                        keyInfo = utilities.getFile(keyinfoFilePath)
                        myFileContents = myFileContents.replace("ServerCert_PH",removeXMLheading(keyInfo))
                                                
                self.download_url = self.download_url+parametersFilename
                if not utilities.putFile(downloadFile, myFileContents):
                    self.notification = self.errormessage + "<br>Could not store generated file."
                    self.download_url = ''
                    self.status = False
            else:
                self.notification = self.errormessage + "<br>No participant template file found."
                self.download_url = ''
                self.status = False
                 
            # Present web page with results
            if self.status:
                self.Presentation()
                return True
            else:
                self.PrepareErrorPages()
                print self.dataERR
                return True
