"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import sys
import os
import smtplib
from email.mime.text import MIMEText

def SendMail(script, smtpserver, textfile, me, subject, placeholders, *argv):
    if not smtpserver:
        return

    fp = open(textfile, 'rb')
    body = fp.read()
    fp.close()
    
    body = body.replace('__REFID_PH__', placeholders['RefID'])
    body = body.replace('__DOWNLOADID_PH__', placeholders['DownloadID'])
    body = body.replace('__PERSOONSNAAM_PH__', placeholders['Naam'])
    body = body.replace('__EMAIL_PH__', placeholders['Email'])
    #print placeholders
    #print smtpserver
    msg = MIMEText(body)
    msg['Subject'] = subject
    msg['From'] = me
    msg['To'] = placeholders['Email']
    #msg['CC'] = you
    if placeholders['EmailSP']:
        maillist = [placeholders['Email'], placeholders['EmailSP']]
    else:
        maillist = [placeholders['Email']]
    # Send the message via our own SMTP server, but don't include the
    # envelope header.
    s = smtplib.SMTP()
    s.connect(smtpserver)
    #s.login("hallo","hallo")
    s.sendmail(me, maillist, msg.as_string())
    s.close()

if __name__ == '__main__':
    SendMail(*sys.argv)
