"""
    ******************************************************

	European Union Public Licence - EUPL v.1.1

	Copyright 2010 Justitiele Informatiedienst, EBV, The Netherlands, http://www.justid.nl

	Licensed under the EUPL, Version 1.1 or - as soon they will be approved by the
	European Commission - subsequent versions of the EUPL (the "Licence");
	You may not use this work except in compliance with the Licence.
	You may obtain a copy of the Licence at:

	http://ec.europa.eu/idabc/eupl

	Unless required by applicable law or agreed to in writing, software distributed
	under the Licence is distributed on an "AS IS" basis, 
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the Licence for the specific language governing permissions and limitations
	under the Licence.

    ******************************************************
"""

import os
import utilities
import cgi
import messages

def _(id, language):
    return messages.Translation(id, language)

class WebFormCreateCpaWithIDS:
    def __init__(self):
        self.indexPairIDs = 1
        self.pairValues = {}
        self.indexPairValues = 1
        self.string = ""
        self.message = ""
        self.errormessage = None
        self.language = ""
    def setLanguage(self, l):
        self.language = l
    def createHtmlSelect(self, myHtmlString, myRoles, myParticipantsList):
        self.errormessage = None
        startString = '<!--ASSIGN_TEMPLATE_START-->'
        endString   = '<!--ASSIGN_TEMPLATE_END-->'
        templateString = utilities.getStringPartition(myHtmlString, startString, endString)
        finalString = ""
        templateStringN = ""

        if not myRoles:
            return False
        
        for role in myRoles:
            [myRoleNo, myPartyNo] = self.getNextPairID()
            templateStringN = templateString
            templateStringN = templateStringN.replace("__PARTYNUMBER_PH__", myRoleNo)
            templateStringN = templateStringN.replace("__ROL_Party_PH__", role)
            templateStringN = templateStringN.replace("__ID_Party_PH__",myPartyNo)
            templateStringN = templateStringN.replace("<!--__OPTION_VALUE_PARAMETERS_PH__-->", myParticipantsList)
            finalString = finalString+templateStringN
        myTemplate = startString+templateString+endString
        self.string = myHtmlString.replace(myTemplate, finalString)
        return True
    def getHtmlString(self):
        return self.string
    def resetPairs(self):
        self.indexPairIDs = 1
        self.pairValues = {}
        self.indexPairValues = 1
        return
    def getNextPairID(self):
        pair = ['Party'+str(self.indexPairIDs)+'_ROLE','Party'+str(self.indexPairIDs)+'_ID']
        self.indexPairIDs = self.indexPairIDs + 1
        return pair
    """
    def getNextPair(self):
        pair = self.pairValues[self.indexPairValues-1]
        self.indexPairValues = self.indexPairValues + 1
        return pair
    """
    def getAssignedRoles(self):
        return self.pairValues
    def addPair(self, myRole, myPartyID):
        self.pairValues[myRole] = myPartyID
        return
    def getPairsFromWebForm(self, myWebForm):
        # Retrieve Party & Role Info Using ID's from WebForm
        self.errormessage = None
        status = True
        message = ""
        #print myWebForm,"<BR>"
        count = 0
        while (status):
            [myRoleNo, myPartyNo] = self.getNextPairID()
            #print "<BR>",myRoleNo,myPartyNo,"<BR>"
            if myWebForm.has_key('Checkbox_'+myRoleNo) and myWebForm['Checkbox_'+myRoleNo].value == "on":
                if myWebForm.has_key(myRoleNo) and myWebForm[myRoleNo].value != "":
                    myRole  = myWebForm[myRoleNo].value
                    if myWebForm.has_key(myPartyNo) and myWebForm[myPartyNo].value != "":
                        myParty  = myWebForm[myPartyNo].value
                        self.addPair(myRole, myParty)
                        #print myRole, myParty,"<BR>"
                        count = count + 1
                    else:
                        #status = False
                        message = message + utilities.redHtmlFormat(_(62, self.language)+myRole+".<BR>")
                else:
                    status = False
            else:
                if not (myWebForm.has_key(myRoleNo) and (myWebForm[myRoleNo].value != "")):
                    status = False

        if (count < 2):
            message = message + utilities.redHtmlFormat(_(63, self.language)) + "<BR>"
            status = False

        if (message == ""):
            status = True
        self.message = message
        return status
    def getKey(self, myWebForm, myKey, myLength):
        self.errormessage = None
        if myWebForm.has_key(myKey):
            if myWebForm[myKey].value != "":
                str = (myWebForm[myKey].value)[0:myLength]
                #print "str1: ",myWebForm[myKey].value
                #print "str2: ",cpacreation.utilities.filterKey(str)
                if utilities.filterKey(str) == str:
                    return utilities.filterKey(str)
                else:
                    self.errormessage = _(64, self.language)
                    return None
        return None
    def getKeyNaam(self, myWebForm, myKey, myLength):
        self.errormessage = None
        if myWebForm.has_key(myKey) and myWebForm[myKey].value != "":
            str = (myWebForm[myKey].value)[0:myLength]
            if utilities.filterName(str) == str:
                return utilities.filterName(str)
            else:
                self.errormessage = _(64, self.language)
        return None
    def getKeyEmail(self, myWebForm, myKey, myLength):
        self.errormessage = None
        if myWebForm.has_key(myKey) and myWebForm[myKey].value != "":
            str = (myWebForm[myKey].value)[0:myLength]
            email = utilities.filterEmail(str)
            if email:
                if email == str:
                    return email
                else:
                    self.errormessage = _(65, self.language)
            else:
                self.errormessage = _(65, self.language)
        return None
    def getKeyDatum(self, myWebForm, myKey, myLength):
        self.errormessage = None
        if myWebForm.has_key(myKey) and myWebForm[myKey].value != "":
            str = (myWebForm[myKey].value)[0:myLength]
            datum = utilities.filterDatum(str)
            if datum:
                if datum == str:
                    return datum
                else:
                    self.errormessage = _(66, self.language)
            else:
                self.errormessage = _(67, self.language)
        return None
    def hasKey(self,myWebForm, myKey, myLength):
        self.errormessage = None
        if self.getKey(myWebForm, myKey, myLength):
            return True
        else:
            return False
        return
    def getFile(self, myWebForm, myKey, myLength, myFilename, myFilesize):
        self.errormessage = None
        try:
            if myWebForm.has_key(myKey):
                fileName=utilities.getFilename((myWebForm[myKey].filename)[0:myLength])
                if len(fileName) < 1:
                    self.errormessage = _(18, self.language)
                    return None
                #if fileName != self.filterName(fileName):
                #    self.errormessage = "De filenaam bevat ongeldige karakters."
                #    return None
                # Er wordt niets met de fileName gedaan behalve dan in het scherm laten zien...
                
                fileContent = myWebForm[myKey]
                fileSize = len(fileContent.value)
                if (fileSize > 0) and (fileSize < myFilesize):
                    if myFilename:
                        writeToFile = file (myFilename, 'wb')
                        while 1:
                            chunk = fileContent.file.read(10000)
                            if not chunk:
                                break
                            writeToFile.write (chunk)
                        writeToFile.close()            
                else:
                    if fileSize >= myFilesize:
                         self.errormessage = _(68, self.language) + "(" + fileName +") Maximum = "+str(myFilesize/1024)+" KByte)."
                    else:
                        self.errormessage = _(69, self.language) + "(" + fileName + ")"
                    return None
            else:
                self.errormessage = _(70, self.language)
                return None

            return fileName
        except:
            self.errormessage = _(71, self.language)
            return None
